#include <errno.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "fail.h"
#include "remtty.h"

void fail(char *reason, ...) {
  va_list vl;

  va_start(vl, reason);
  vfprintf(stderr, reason, vl);
  va_end(vl);
  exit(EXIT_FAILURE);
}

void warn(char *reason, ...) {
  va_list vl;

  va_start(vl, reason);
  vfprintf(stderr, reason, vl);
  va_end(vl);
}

void info(char *reason, ...) {
  va_list vl;

  if (verbose) {
    va_start(vl, reason);
    vfprintf(stderr, reason, vl);
    va_end(vl);
  }
}
