#include <stdlib.h>
#include <stdio.h>
#include <pty.h>
#include <fcntl.h>

#include "pty.h"
#include "fail.h"

#if defined(__GLIBC__) || defined(SVR4)
#define HAVE_GRANTPT
#endif

int get_pty(char **result) {
  int pty = -1;
  int rc;
  char *name;

  pty = open("/dev/ptmx", O_RDWR);
  if (pty < 0) {
    return -1;
  }

  rc = grantpt(pty);
  if (rc < 0) {
    close(pty);
    return -1;
  }

  rc = unlockpt(pty);
  if (rc < 0) {
    close(pty);
    return -1;
  }

  name = (char *) ptsname(pty);
  if (NULL == name) {
    close(pty);
    return -1;
  }

  *result = (char *) malloc(strlen(name)+1);
  if (NULL == *result) {
    close(pty);
    return -1;
  }

  strcpy(*result, name);

  return pty;
}
