
#include <stdio.h>	/*(printf)*/
#include <termios.h>	/*ICANON,TCSA...*/
#include <signal.h>	/*SIGTERM*/
#include <stdlib.h>	/*(atexit)*/
#include <unistd.h>	/*(isatty)*/

#include "stty.h"	/*(setTty)*/

static void sigint(int i) {
  exit(1);
}

static struct termios old_termios;

static void recover_termios() {
  tcsetattr(0, TCSADRAIN, &old_termios);
}

void set_tty(void) {
  struct termios t;
  
  if (!isatty(0)) return;

  signal(SIGTERM, sigint);
  signal(SIGINT, sigint);
  tcgetattr(0, &t);
  old_termios = t;
  atexit(recover_termios);

/*   t.c_lflag &= ~ICANON & ~ECHO & ~ISIG; */
  t.c_lflag &= ~ICANON & ~ECHO;
  t.c_iflag &= ~ICRNL & ~INLCR;
  t.c_oflag &= ~OCRNL & ~ONLCR;
  t.c_cc[VMIN] = 1;
  t.c_cc[VTIME] = 0;
  tcsetattr(0, TCSADRAIN, &t);
}
